

#include "Network/Network.h"
#include "MarkerDetector/MarkerDetector.h"

#include <cv.h>
#include <highgui.h>
#pragma comment(lib,"cv200.lib")
#pragma comment(lib,"cxcore200.lib")
#pragma comment(lib,"highgui200.lib")

#pragma comment(lib,"libAR.lib")
#pragma comment(lib,"libARgsub.lib")
#pragma comment(linker,"/NODEFAULTLIB:libcmt.lib")

#include <vector>
#include <fstream>

typedef struct {
	BOOL name;
	BOOL pos2d;
	BOOL dvec;
	BOOL pos3d;
	BOOL glmatrix;
	BOOL cf;
	BOOL area;
	BOOL vertex;
} DATA_ENABLE_LIST;


void SendSameNamedData( Network *net, const vector<AR_OBJECT> &marker_info, DATA_ENABLE_LIST enable_list, string &name );
void SendAllData( Network *net, const vector<AR_OBJECT> &marker_info, DATA_ENABLE_LIST enable_list );
void cvuDrawString( IplImage *image, const char *text, CvPoint pos, CvScalar color, double scale);
int DrawMarkerLine( IplImage *image, AR_OBJECT &object, CvScalar color, int thickness = 1, int line_type = 8, int shift = 0);
void DrawMarkerInfo( IplImage *image, AR_OBJECT &object );
void Detection( IplImage* imgIn, IplImage *imgARTK,int thresh, const vector<PATTERN_DATA> &pattern_list, vector<AR_OBJECT> &detected_markers );
void MakeMarkerInfoString( const AR_OBJECT &object, DATA_ENABLE_LIST elist, char buf[], int bufsize );
void MakeDataFormatString( DATA_ENABLE_LIST elist, char buf[], int bufsize );
int GetIpAddress( char *ip_address, int bufsize );