// VisionServerDlg.cpp
//


// }[JuāC_ɂ@\C}`}[J
// 摜1chł΍łD
// ƂnyatlâgČvZłD
// ̒CɓȂ̂łǂɂׂD


// }[J̃TCYCt@CC摜f[^\@\
// ̐ݒۑ@\قD
// ̃XbhIĂȂƂɋNł낤ۂɂ
// CĂقD
// ɓIɂ̓AvP[V𗎂Ƃ̂Ԃ@̂悤ȋCD

// 臒lݒ@\
// Iԋ@\
// }[Jo^@\
// g}[JI@\
// Lu[V@\
// XbhN܂Ƀ|[gԍ̃`FbN͂ĂقD

#include "stdafx.h"
#include "VisionServer.h"
#include "VisionServerDlg.h"
#include "DetectServer.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#define IDM_DELETE_ITEM 1500


static boost::mutex	g_mtServerEnable;
static bool g_serverEnable = false;
static boost::mutex g_mtMarkerInfo;
static vector<AR_OBJECT> g_markerInfo;
static bool g_auto_dataflow;
static DATA_ENABLE_LIST g_enable_list;



string CString2string( const CString &src )
{
	char *cbuf = new char[src.GetLength()+1];
	int k;
	for ( k=0; k< src.GetLength(); k++) {
		cbuf[k] = src[k];
	}
	cbuf[k]='\0';
	string dst = cbuf;
	delete[] cbuf;

	return dst;
}

int InterpretCommand( string line, DATA_ENABLE_LIST enable_list, Network *net)
{
	stringstream ss(line);
	string cmd;
	ss >> cmd;

	if ( cmd=="get") {
		string name;
		ss >> name;
		
		g_mtMarkerInfo.lock();
			SendSameNamedData( net, g_markerInfo, enable_list, name );
		g_mtMarkerInfo.unlock();
	}
	else if ( cmd=="all") {
		g_mtMarkerInfo.lock();
			SendAllData( net, g_markerInfo, enable_list );
		g_mtMarkerInfo.unlock();
	}
	else if ( cmd=="help" ) {
		net->send_message("<<< COMMAND LIST >>>\n");
		net->send_message("all        Get all marker information.\n");
		net->send_message("get <name> Get marker information having specified name.\n");			
		net->send_message("help       Show command list.\n");
		net->send_message("exit       Dissconnect this connection.\n");
		net->send_message("quit       Dissconnect this connection.\n");
		net->send_message("\n");
	}
	else if ( cmd=="quit" || cmd=="exit" ) {
		net->send_message("*ok\n");
		return -1;
	}
	else {
		net->send_message("*error\n");
	}
	return 0;
}


void Server(Network &net)
{
	// [vɓ܂Ƀf[^̂ł΂댯͂Ȃ͂D
	bool is_auto_mode = g_auto_dataflow;
	DATA_ENABLE_LIST enable_list = g_enable_list;
	//-------------------------------------------------

	int ms;
	LARGE_INTEGER freq, time_curr, time_prev;
	QueryPerformanceFrequency(&freq);
	QueryPerformanceCounter(&time_prev);

	while (1) {
		// to make constant communication rate -----------------------------------------
		for (;;) {
			QueryPerformanceCounter(&time_curr);
			ms = (time_curr.QuadPart - time_prev.QuadPart)*1000 / freq.QuadPart;
			if (ms>=33) break;
		}
		time_prev = time_curr;

		// Check pushing stop button --------------------------------------------
		g_mtServerEnable.lock();
		if ( !g_serverEnable ) {
			g_mtServerEnable.unlock();
			return;
		}
		g_mtServerEnable.unlock();

		// Send result ----------------------------------------------------------
		// AUTOMATIC MODE
		if ( is_auto_mode ) {
			g_mtMarkerInfo.lock();
				SendAllData( &net, g_markerInfo, enable_list );
			g_mtMarkerInfo.unlock();
		}
		// REQUEST MODE
		else {
			string msg = net.read_message();
			if (msg.size() == 0) break;
			stringstream ss(msg);
			string line;
			while ( getline(ss,line) ) {
				int ret = InterpretCommand(line,enable_list,&net);
				if (ret==-1) return;
			}
		}
	}
}



//------------------------------------------------------------------------------------
// rbg}bvBITMAPFILEHEADER\̂쐬֐
void MakeBitmapFileHeader(BITMAPINFOHEADER bmih,BITMAPFILEHEADER &bmfh)
{
	bmfh.bfType = 'B' + ('M'<<8);
	bmfh.bfOffBits = 0x36;			//wb_̈̃oCg
	if (bmih.biBitCount<=8) {
		bmfh.bfOffBits += sizeof(COLORREF) * (1 << bmih.biBitCount);
	}

	bmfh.bfSize = bmfh.bfOffBits + bmih.biSizeImage;
	bmfh.bfReserved1 = 0x00;
	bmfh.bfReserved2 = 0x00;
}
//------------------------------------------------------------------------------------
// BITMAPINFOHEADER\̂쐬֐
void MakeBitmapInfoHeader(long width,long height,unsigned short bitcount,BITMAPINFOHEADER &bmih)
{
	bmih.biSize = 0x28;
	bmih.biWidth = width;
	bmih.biHeight = height;
	bmih.biPlanes = 0x01;
	bmih.biBitCount = bitcount;
	bmih.biCompression = 0x00;
	bmih.biSizeImage = height*(width*3 + width%4);
	bmih.biXPelsPerMeter = 0x00;
	bmih.biYPelsPerMeter = 0x00;
	bmih.biClrUsed = 0x00;
	bmih.biClrImportant = 0x00;
}
//------------------------------------------------------------------------------------
// 24bitrbg}bvBITMAPINFO\̂쐬֐
void MakeBitmapInfo24(long width,long height,BITMAPINFO &bmi)
{
	MakeBitmapInfoHeader(width,height,24,bmi.bmiHeader);
	memset(&bmi.bmiColors,0,sizeof(RGBQUAD));
}

void CVisionServerDlg::ShowImage( int nID, IplImage *image )
{
	if (image==NULL) return;

	CWnd*	pWnd = GetDlgItem(nID);				//sN`ւ̃|C^
	HDC		hDC = pWnd->GetDC()->GetSafeHdc();	//摜̈̃nh
	RECT	rect;								//`̈
	pWnd->GetClientRect(&rect);

	int SrcY = 0;
	int ViewWidth = rect.right;
	int ViewHeight = rect.bottom;
	int SrcWidth = image->width;
	int SrcHeight = image->height;

	//͂ݏo
	if (ViewWidth <= SrcWidth){
		SrcWidth = ViewWidth;
	}else{
		ViewWidth = SrcWidth;
	}

	BITMAPINFO bmi;
	MakeBitmapInfo24(image->width,image->height,bmi);

	//c͂ݏo
	if (ViewHeight <= SrcHeight){
		SrcY = SrcHeight - ViewHeight;	//؂̂ʏ㕔ɂȂ悤ɂĂ 
		SrcHeight = ViewHeight;
	}else{
		ViewHeight = SrcHeight;
	}

	StretchDIBits(  hDC,
				/*
				0, rect.bottom,
				rect.right, -rect.bottom,
				0,0,
				image->width, image->height,
				*/
				0, ViewHeight,
				ViewWidth, -ViewHeight,
				0,0,
				SrcWidth, SrcHeight,
				image->imageData,
				&bmi,
				DIB_RGB_COLORS,SRCCOPY);

	::ReleaseDC(m_hWnd,hDC);	//IuWFNg̉(K{!!)
}



typedef struct {
	bool L;
	bool R;
	bool M;
	int x;
	int y;
} MOUSE_STATE;

static MOUSE_STATE g_mouse;

void on_mouse (int event, int x, int y, int flags, void *param = NULL)
{
	g_mouse.x = x;
	g_mouse.y = y;

	switch (event) {
		case CV_EVENT_LBUTTONDOWN:
			g_mouse.L = true;
			break;
		case CV_EVENT_LBUTTONUP:
			g_mouse.L = false;
			break;
		case CV_EVENT_RBUTTONDOWN:
			g_mouse.R = true;
			break;
		case CV_EVENT_RBUTTONUP:
			g_mouse.R = false;
			break;
		case CV_EVENT_MBUTTONDOWN:
			g_mouse.M = true;
			break;
		case CV_EVENT_MBUTTONUP:
			g_mouse.M = false;
			break;
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CVisionServerDlg _CAO
CVisionServerDlg::CVisionServerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVisionServerDlg::IDD, pParent)
	, m_edit_port(0)
	, m_combo_camera_id(0)
	, m_combo_image_size(0)
	, m_radio_dataflow(0)
	, m_check_name(FALSE)
	, m_check_pos2d(FALSE)
	, m_check_dvec(FALSE)
	, m_check_pos3d(FALSE)
	, m_check_glmatrix(FALSE)
	, m_check_vertex(FALSE)
	, m_check_area(FALSE)
	, m_check_cf(FALSE)
	, m_edit_data_format(_T(""))
	, m_edit_patt_width(0)
	, m_edit_patt_name(_T(""))
	, m_check_preview(FALSE)
	, m_edit_output(_T(""))
	, m_edit_IP_address(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVisionServerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BUTTON_START, m_button_start);
	DDX_Control(pDX, IDC_BUTTON_STOP, m_button_stop);
	DDX_Text(pDX, IDC_EDIT_PORT, m_edit_port);
	DDX_Control(pDX, IDC_EDIT_PORT, m_cntl_edit_port);
	DDX_CBIndex(pDX, IDC_COMBO_CAMERA_ID, m_combo_camera_id);
	DDX_Control(pDX, IDC_COMBO_CAMERA_ID, m_cntl_combo_camera_id);
	DDX_CBIndex(pDX, IDC_COMBO_IMAGE_SIZE, m_combo_image_size);
	DDX_Control(pDX, IDC_COMBO_IMAGE_SIZE, m_cntl_combo_image_size);
	DDX_Radio(pDX, IDC_RADIO_DATAFLOW1, m_radio_dataflow);
	DDX_Check(pDX, IDC_CHECK_NAME, m_check_name);
	DDX_Check(pDX, IDC_CHECK_POS2D, m_check_pos2d);
	DDX_Check(pDX, IDC_CHECK_DVEC, m_check_dvec);
	DDX_Check(pDX, IDC_CHECK_POS3D, m_check_pos3d);
	DDX_Check(pDX, IDC_CHECK_GLMATRIX, m_check_glmatrix);
	DDX_Check(pDX, IDC_CHECK_VERTEX, m_check_vertex);
	DDX_Check(pDX, IDC_CHECK_AREA, m_check_area);
	DDX_Check(pDX, IDC_CHECK_CF, m_check_cf);
	DDX_Control(pDX, IDC_STATIC_FORMAT, m_cntl_data_format);
	DDX_Control(pDX, IDC_CHECK_NAME, m_cntl_check_name);
	DDX_Control(pDX, IDC_CHECK_POS2D, m_cntl_check_pos2d);
	DDX_Control(pDX, IDC_CHECK_DVEC, m_cntl_check_dvec);
	DDX_Control(pDX, IDC_CHECK_POS3D, m_cntl_check_pos3d);
	DDX_Control(pDX, IDC_CHECK_GLMATRIX, m_cntl_check_glmatrix);
	DDX_Control(pDX, IDC_CHECK_VERTEX, m_cntl_check_vertex);
	DDX_Control(pDX, IDC_CHECK_AREA, m_cntl_check_area);
	DDX_Control(pDX, IDC_CHECK_CF, m_cntl_check_cf);
	DDX_Text(pDX, IDC_EDIT_DATA_FORMAT, m_edit_data_format);
	DDX_Control(pDX, IDC_RADIO_DATAFLOW1, m_cntl_radio_dataflow1);
	DDX_Control(pDX, IDC_RADIO_DATAFLOW2, m_cntl_radio_dataflow2);
	DDX_Control(pDX, IDC_LIST_PATTERN, m_cntl_list_pattern);
	DDX_Control(pDX, IDC_BUTTON_START_PATTERN_CAPTURE, m_cntl_button_patt_capture);
	DDX_Control(pDX, IDC_EDIT_PATTERN_NAME, m_cntl_edit_patt_name);
	DDX_Control(pDX, IDC_EDIT_PATTERN_WIDTH, m_cntl_edit_patt_width);
	DDX_Text(pDX, IDC_EDIT_PATTERN_WIDTH, m_edit_patt_width);
	DDX_Text(pDX, IDC_EDIT_PATTERN_NAME, m_edit_patt_name);
	DDX_Check(pDX, IDC_CHECK_PREVIEW, m_check_preview);
	DDX_Control(pDX, IDC_CHECK_PREVIEW, m_cntl_check_preview);
	DDX_Control(pDX, IDC_BUTTON_SAVE_PATTERN_INFO, m_cntl_button_save_patt_info);
	DDX_Control(pDX, IDC_EDIT_OUTPUT, m_cntl_edit_output);
	DDX_Text(pDX, IDC_EDIT_OUTPUT, m_edit_output);
	DDX_Text(pDX, IDC_EDIT_IP_ADDRESS, m_edit_IP_address);
}

BEGIN_MESSAGE_MAP(CVisionServerDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, &CVisionServerDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, &CVisionServerDlg::OnBnClickedCancel)
	ON_BN_CLICKED(IDC_BUTTON_STOP, &CVisionServerDlg::OnBnClickedButtonStop)
	ON_BN_CLICKED(IDC_BUTTON_START, &CVisionServerDlg::OnBnClickedButtonStart)
	ON_BN_CLICKED(IDC_CHECK_NAME, &CVisionServerDlg::OnBnClickedCheckName)
	ON_BN_CLICKED(IDC_CHECK_POS2D, &CVisionServerDlg::OnBnClickedCheckPos2d)
	ON_BN_CLICKED(IDC_CHECK_DVEC, &CVisionServerDlg::OnBnClickedCheckDvec)
	ON_BN_CLICKED(IDC_CHECK_POS3D, &CVisionServerDlg::OnBnClickedCheckPos3d)
	ON_BN_CLICKED(IDC_CHECK_AREA, &CVisionServerDlg::OnBnClickedCheckArea)
	ON_BN_CLICKED(IDC_CHECK_CF, &CVisionServerDlg::OnBnClickedCheckCf)
	ON_BN_CLICKED(IDC_CHECK_VERTEX, &CVisionServerDlg::OnBnClickedCheckVertex)
	ON_BN_CLICKED(IDC_CHECK_GLMATRIX, &CVisionServerDlg::OnBnClickedCheckGlmatrix)
	ON_NOTIFY(NM_RCLICK, IDC_LIST_PATTERN, &CVisionServerDlg::OnNMRClickListPattern)
	ON_BN_CLICKED(IDC_BUTTON_START_PATTERN_CAPTURE, &CVisionServerDlg::OnBnClickedButtonStartPatternCapture)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST_PATTERN, &CVisionServerDlg::OnLvnItemchangedListPattern)
	ON_BN_CLICKED(IDM_DELETE_ITEM,&CVisionServerDlg::DeleteItemFromList)
	ON_BN_CLICKED(IDC_BUTTON_SAVE_PATTERN_INFO, &CVisionServerDlg::OnBnClickedButtonSavePatternInfo)
END_MESSAGE_MAP()


// CVisionServerDlg bZ[W nh

BOOL CVisionServerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[VXe j[ɒǉ܂B

	// IDM_ABOUTBOX ́AVXe R}h͈͓̔ɂȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}
	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);		// Large Icon Config
	SetIcon(m_hIcon, FALSE);	// Small Icon Config

	// TODO: Init here ////////////////////////////////////////////////////////////
	
	char ip_address[256];
	GetIpAddress(ip_address,sizeof(ip_address));
	m_edit_IP_address = ip_address;

	// load config
	LoadConfigFile("Data/config.txt");

	// camera ID
	for (int i=0; i<m_max_camera_num; i++) {
		WCHAR  wcbuf[256];
		wsprintf(wcbuf,TEXT("%d"),i);
		m_cntl_combo_camera_id.InsertString(i,wcbuf);
	}
	UpdateData(false);

	// Image size
	for (unsigned int i=0; i<m_size_list.size(); i++) {
		WCHAR  wcbuf[256];
		wsprintf(wcbuf,TEXT("%dx%d"),m_size_list[i].width,m_size_list[i].height);
		m_cntl_combo_image_size.InsertString(i,wcbuf);
	}
	UpdateData(false);

	// Load Pettern info
	vector<PATTERN_DATA> pattList;
	LoadPatternList("Data/pattern_list.txt",pattList);
	int err = 0;
	if (!err) err = InitList();
	for (unsigned int i=0; i<pattList.size(); i++) {
		if (!err) err = InsertItemToList(pattList[i]);
	}
	UpdateData(false);

	MakeDataFormat();

	m_imgPatt = NULL;
	if ( m_cntl_list_pattern.GetItemCount()==0 ) {
		m_imgPatt = cvLoadImage("no_pattern.bmp");
		ShowImage( IDC_PICT_PATT, m_imgPatt );
	}

	m_cntl_list_pattern.SetItemState( 0, LVIS_SELECTED|LVIS_FOCUSED,LVIS_SELECTED|LVIS_FOCUSED );

//	m_camera = NULL;
	m_pThread = NULL;
	m_pPattCapThread = NULL;	 
	m_loopEnable = false;
	m_PattCapLoopEnable = false;

	return TRUE;
}

	
int CVisionServerDlg::LoadConfigFile( const char *filename )
{
	ifstream fin(filename);
	if (!fin) {
		cout << filename << " can not open.\n";
		return -1;
	}
	string word;
	while (fin >> word) {
		if (word=="[Port]") {
			fin >> m_edit_port;
		}
		else if (word=="[MaxCameraNum]") {
			fin >> m_max_camera_num;
		}
		else if (word=="[CameraSelected]") {
			fin >> m_combo_camera_id;
		}
		else if (word=="[ImageSizeList]") {
			int width,height;
			fin >> width >> height;
			m_size_list.push_back(cvSize(width,height));
		}
		else if (word=="[ImageSizeSelected]") {
			fin >> m_combo_image_size;
		}
		else if (word=="[DataFlow]") {
			fin >> m_radio_dataflow;
		}
		else if (word=="[CheckName]") {
			fin >> m_check_name;
		}
		else if (word=="[CheckPos2d]") {
			fin >> m_check_pos2d;
		}
		else if (word=="[CheckDvec]") {
			fin >> m_check_dvec;
		}
		else if (word=="[CheckPos3d]") {
			fin >> m_check_pos3d;
		}
		else if (word=="[CheckCf]") {
			fin >> m_check_cf;
		}
		else if (word=="[CheckArea]") {
			fin >> m_check_area;
		}
		else if (word=="[CheckVertex]") {
			fin >> m_check_vertex;
		}
		else if (word=="[CheckGLmatrix]") {
			fin >> m_check_glmatrix;
		}
		else if (word=="[CheckPreview]") {
			fin >> m_check_preview;
		}
		else if (word=="[DefaultPatternWidth]") {
			fin >> m_default_patt_width;
		}
	}
	UpdateData(false);
	fin.close();
	return 0;
}

int CVisionServerDlg::SaveConfigFile( const char * filename )
{
	ofstream fout(filename);
	if (!fout) {
		return -1;
	}

	UpdateData(true);
	fout << "[Port]                " << m_edit_port << "\n";
	fout << "[MaxCameraNum]        " << m_max_camera_num << "\n";
	fout << "[CameraSelected]      " << m_combo_camera_id << "\n";
	for (unsigned int i=0; i<m_size_list.size(); i++) {
		fout << "[ImageSizeList]       " << m_size_list[i].width << " " << m_size_list[i].height << "\n";
	}
	fout << "[ImageSizeSelected]   " << m_combo_image_size << "\n";
	fout << "[DataFlow]            " << m_radio_dataflow << "\n";
	fout << "[CheckName]           " << m_check_name << "\n";
	fout << "[CheckPos2d]          " << m_check_pos2d << "\n";
	fout << "[CheckDvec]           " << m_check_dvec << "\n";
	fout << "[CheckPos3d]          " << m_check_pos3d << "\n";
	fout << "[CheckCf]             " << m_check_cf << "\n";
	fout << "[CheckArea]           " << m_check_area << "\n";
	fout << "[CheckVertex]         " << m_check_vertex << "\n";
	fout << "[CheckGLmatrix]       " << m_check_glmatrix << "\n";
	fout << "[CheckPreview]        " << m_check_preview << "\n";
	fout << "[DefaultPatternWidth] " << m_default_patt_width << "\n";

	fout.close();
	return 0;
}


void CVisionServerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CVisionServerDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		ShowImage( IDC_PICT_PATT, m_imgPatt );
		CDialog::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CVisionServerDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CVisionServerDlg::OnBnClickedOk()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	OnOK();
}


BOOL CVisionServerDlg::PreTranslateMessage(MSG* pMsg)
{
    switch(pMsg->message){
        case WM_KEYDOWN:
            switch(pMsg->wParam){
                case VK_RETURN:return TRUE;
                case VK_ESCAPE:return TRUE;
            }
    }
    return CDialog::PreTranslateMessage(pMsg);
}

// X button
void CVisionServerDlg::OnBnClickedCancel()
{
	if ( m_pThread != NULL ) {
		MessageBox( TEXT("Please stop server") );
		return;
	}

	if ( m_pPattCapThread != NULL) {
		MessageBox( TEXT("Please close pattern capture") );
		return;
	}

	cvReleaseImage(&m_imgPatt);
	m_imgPatt = NULL;

	SavePatternList("Data/pattern_list.txt");
	SaveConfigFile("Data/config.txt");

	OnCancel();
}


// Lock UI
void CVisionServerDlg::LockInterface()
{
	m_button_start.EnableWindow(false);
	m_cntl_button_patt_capture.EnableWindow(false);

	m_cntl_combo_camera_id.EnableWindow(false);
	m_cntl_combo_image_size.EnableWindow(false);
	m_cntl_radio_dataflow1.EnableWindow(false);
	m_cntl_radio_dataflow2.EnableWindow(false);

	m_cntl_check_name.EnableWindow(false);
	m_cntl_check_pos2d.EnableWindow(false);
	m_cntl_check_dvec.EnableWindow(false);
	m_cntl_check_pos3d.EnableWindow(false);
	m_cntl_check_glmatrix.EnableWindow(false);
	m_cntl_check_cf.EnableWindow(false);
	m_cntl_check_area.EnableWindow(false);
	m_cntl_check_vertex.EnableWindow(false);

	m_cntl_edit_port.SetReadOnly(true);
	m_cntl_edit_patt_width.SetReadOnly(true);
	m_cntl_edit_patt_name.SetReadOnly(true);
	m_cntl_button_save_patt_info.EnableWindow(false);
}

// Unlock UI
void CVisionServerDlg::UnlockInterface()
{
	m_button_start.EnableWindow(true);
	m_cntl_button_patt_capture.EnableWindow(true);

	m_cntl_edit_port.EnableWindow(true);
	m_cntl_combo_camera_id.EnableWindow(true);
	m_cntl_combo_image_size.EnableWindow(true);
	m_cntl_data_format.EnableWindow(true);
	m_cntl_radio_dataflow1.EnableWindow(true);
	m_cntl_radio_dataflow2.EnableWindow(true);

	m_cntl_check_name.EnableWindow(true);
	m_cntl_check_pos2d.EnableWindow(true);
	m_cntl_check_dvec.EnableWindow(true);
	m_cntl_check_pos3d.EnableWindow(true);
	m_cntl_check_glmatrix.EnableWindow(true);
	m_cntl_check_cf.EnableWindow(true);
	m_cntl_check_area.EnableWindow(true);
	m_cntl_check_vertex.EnableWindow(true);

	m_cntl_edit_port.SetReadOnly(false);
	m_cntl_edit_patt_width.SetReadOnly(false);
	m_cntl_edit_patt_name.SetReadOnly(false);
	m_cntl_button_save_patt_info.EnableWindow(true);
}

// StopButton
void CVisionServerDlg::OnBnClickedButtonStop()
{
	m_loopEnable = false;
}

// Start Button
void CVisionServerDlg::OnBnClickedButtonStart()
{
	// Get settings from GUI
	UpdateData();

	// CameraSetup
	//m_camera = cvCreateCameraCapture(m_combo_camera_id);
	//if ( m_camera == NULL ) {
	//	MessageBox(TEXT("Camera could not be connected.\r\nAnother software probably uses it."), TEXT("Error"), MB_ICONERROR | MB_OK);
	//	return;
	//}
	//cvSetCaptureProperty( m_camera, CV_CAP_PROP_FRAME_WIDTH, m_size_list[m_combo_image_size].width );
	//cvSetCaptureProperty( m_camera, CV_CAP_PROP_FRAME_HEIGHT, m_size_list[m_combo_image_size].height );

	int ret = m_capture.Init(m_combo_camera_id);
	if ( ret == -1 ) {
		MessageBox(TEXT("Camera could not be connected.\r\nAnother software probably uses it."), TEXT("Error"), MB_ICONERROR | MB_OK);
		return;
	}
	m_capture.SetConfig( m_size_list[m_combo_image_size].width, m_size_list[m_combo_image_size].height, 30.0 );

	// Enable list from checkbox
	g_enable_list.name  = m_check_name;
	g_enable_list.pos2d = m_check_pos2d;
	g_enable_list.dvec  = m_check_dvec;
	g_enable_list.pos3d = m_check_pos3d;
	g_enable_list.glmatrix = m_check_glmatrix;
	g_enable_list.cf       = m_check_cf;
	g_enable_list.area     = m_check_area;
	g_enable_list.vertex   = m_check_vertex;

	// data flow
	g_auto_dataflow = (m_radio_dataflow==0);

	// Pattern list
	PATTERN_DATA patt;
	m_pattern_list.clear();
	for (int i=0; i<m_cntl_list_pattern.GetItemCount(); i++) {

		patt.id       = i;
		patt.enable   = (m_cntl_list_pattern.GetCheck(i) ? true : false);
		patt.name     = CString2string( m_cntl_list_pattern.GetItemText(i, 0) );
		patt.width    = _tstof(m_cntl_list_pattern.GetItemText(i, 1));

		char filename[256];
		sprintf_s( filename, sizeof(filename), "Data/%03d.patt",i); 
		patt.filename = filename;
		m_pattern_list.push_back(patt);
	}

	// Lock GUI and activate thread.
	LockInterface();

	// ɃG[`FbNI
	m_pThread = AfxBeginThread(Thread,this);
}


int CVisionServerDlg::SavePatternList(const char *filename)
{
	ofstream fout(filename);

	if (!fout) {
		return -1;
	}

	// t@C͏ԈˑȎdg݂ɂȂĂ邯ǁCǂ̂EEE
	// ̂܂ǂɂD/DatatȂ肷̂ʓ|D

	vector<PATTERN_DATA> pattList;
	PATTERN_DATA patt;
	pattList.clear();
	for (int i=0; i<m_cntl_list_pattern.GetItemCount(); i++) {
		patt.enable = (m_cntl_list_pattern.GetCheck(i) ? true : false);
		patt.id       = i;
		patt.name     = CString2string( m_cntl_list_pattern.GetItemText(i, 0) );
		patt.width    = _tstof(m_cntl_list_pattern.GetItemText(i, 1));
		char filename[256];
		sprintf_s( filename, sizeof(filename), "Data/%03d.patt",i); 
		patt.filename = filename;
		pattList.push_back(patt);
	}

	for (unsigned int i=0; i<pattList.size(); i++) {
		
		fout << "[Pattern]" << "\t" 
			 << pattList[i].name << "\t" 
			 << pattList[i].filename << "\t"
			 << pattList[i].width << "\t"
			 << (pattList[i].enable? "use" : "not_use") << "\n";
	}

	fout.close();

	return 0;
}


void CVisionServerDlg::OnBnClickedButtonStartPatternCapture()
{
	// Get settings from GUI
	UpdateData();

	// CameraSetup
	//m_camera = cvCreateCameraCapture(m_combo_camera_id);
	//if ( m_camera == NULL ) {
	//	MessageBox(TEXT("Camera could not be connected.\r\nAnother software probably uses it."), TEXT("Error"), MB_ICONERROR | MB_OK);
	//	return;
	//}
	//cvSetCaptureProperty( m_camera, CV_CAP_PROP_FRAME_WIDTH, m_size_list[m_combo_image_size].width );
	//cvSetCaptureProperty( m_camera, CV_CAP_PROP_FRAME_HEIGHT, m_size_list[m_combo_image_size].height );

	int ret = m_capture.Init(m_combo_camera_id);
	if ( ret == -1 ) {
		MessageBox(TEXT("Camera could not be connected.\r\nAnother software probably uses it."), TEXT("Error"), MB_ICONERROR | MB_OK);
		return;
	}
	m_capture.SetConfig( m_size_list[m_combo_image_size].width, m_size_list[m_combo_image_size].height, 30.0 );

	m_cntl_button_patt_capture.EnableWindow(false);
	m_button_start.EnableWindow(false);
	m_button_stop.EnableWindow(false);

	// ɃG[`FbNI
	m_pPattCapThread = AfxBeginThread(PattCapThread,this);
}

// Thread (Parent)
UINT CVisionServerDlg::Thread(LPVOID pParam)
{
	((CVisionServerDlg*)pParam)->Thread();
	return 0;
}

// Thread (Parent)
UINT CVisionServerDlg::PattCapThread(LPVOID pParam)
{
	((CVisionServerDlg*)pParam)->PattCapThread();
	return 0;
}



// ȈՓIɁD
bool InBoundingBox( const ARMarkerInfo *marker, int x, int y )
{
	int max_x=-1, min_x=10000, max_y=-1, min_y=10000;

	for (int i=0; i<4; i++) {
		if ( max_x < marker->vertex[i][0] ) max_x = marker->vertex[i][0];
		if ( max_y < marker->vertex[i][1] ) max_y = marker->vertex[i][1];
		if ( min_x > marker->vertex[i][0] ) min_x = marker->vertex[i][0];
		if ( min_y > marker->vertex[i][1] ) min_y = marker->vertex[i][1];
	}
	return ( min_x <= x && min_y <= y && x <= max_x && y < max_y );
}


int DrawMarkerLine2( IplImage *image, const ARMarkerInfo *marker,
				    CvScalar color, int thickness=2, int line_type=8, int shift=0 )
{
	// edge line
	CvPoint v[4];
	v[0] = cvPoint(marker->vertex[2][0], marker->vertex[2][1]);
	v[1] = cvPoint(marker->vertex[3][0], marker->vertex[3][1]);
	v[2] = cvPoint(marker->vertex[0][0], marker->vertex[0][1]);
	v[3] = cvPoint(marker->vertex[1][0], marker->vertex[1][1]);
	for (int i=0; i<4; i++) {
		cvLine( image, v[i], v[(i+1)%4], color, thickness, line_type, shift );
	}
	
	// direction vector
	CvPoint vec[2];

	for (int i=0; i<2; i++) {
		vec[i].x = v[i].x - marker->pos[0];
		vec[i].y = v[i].y - marker->pos[1];
	}
	CvPoint dvecpos;
	dvecpos.x = (vec[0].x + vec[1].x) + marker->pos[0];
	dvecpos.y = (vec[0].y + vec[1].y) + marker->pos[1];

	CvPoint center = cvPoint( marker->pos[0], marker->pos[1] );
	cvLine( image, center, dvecpos, color, thickness, line_type, shift );

	return 0;
}

void ClipImage( const IplImage *src, IplImage *dst, const ARMarkerInfo *marker )
{
	CvMat src_point;
	double a[] = {
		marker->vertex[2][0], marker->vertex[2][1],
		marker->vertex[3][0], marker->vertex[3][1],
		marker->vertex[0][0], marker->vertex[0][1],
		marker->vertex[1][0], marker->vertex[1][1]
	};
	src_point = cvMat( 4, 2, CV_64FC1, a );


	CvMat dst_point;
	double b[] = {
		0, 0,
		dst->width - 1, 0,
		dst->width - 1, dst->height - 1,
		0, dst->height - 1
	};

	dst_point = cvMat( 4, 2, CV_64FC1, b );
	CvMat *h = cvCreateMat( 3, 3, CV_64FC1 );

	cvFindHomography( &src_point, &dst_point, h );
	cvWarpPerspective( src, dst, h );
}


// Thread (Main)
void CVisionServerDlg::PattCapThread()
{
	m_PattCapLoopEnable = true;

	// Window Setup --------------------------------------------------------------------------
	char *win = "Pattern Capture";
	cvNamedWindow(win);
	cvSetMouseCallback(win,on_mouse);

	// Image for ARToolKit Setup -------------------------------------------------------------
//	int width = cvQueryFrame(m_camera)->width;
//	int height = cvQueryFrame(m_camera)->height;
	int width = m_capture.QueryFrame()->width;
	int height = m_capture.QueryFrame()->height;

	IplImage* imgARTK = cvCreateImage(cvSize(width,height),IPL_DEPTH_8U, 4);
	IplImage* imgFrame = NULL;	// do not release

	// Camera parameter setup ----------------------------------------------------------------
	ARParam cparam;
	ARParam wparam;
	arParamLoad("Data/camera_para.dat",1,&wparam);
	arParamChangeSize(&wparam,width,height,&cparam);
	arParamDisp(&cparam);
	arInitCparam(&cparam);

	ARMarkerInfo *marker_info;
	int marker_num;
	bool prev_mouseL = false;

	IplImage* imgClip = cvCreateImage( cvSize(80,80),IPL_DEPTH_8U, 4 );

	// Image Processing Loop
	while (m_PattCapLoopEnable) {
		//imgFrame = cvQueryFrame(m_camera);
		imgFrame = m_capture.QueryFrame();

		cvCvtColor(imgFrame,imgARTK,CV_BGR2BGRA);
		arDetectMarker( (ARUint8*)(imgARTK->imageData), 100, &marker_info, &marker_num );

		int k=-1;
		for (int i=0; i<marker_num; i++) {
			if ( InBoundingBox( &marker_info[i], g_mouse.x, g_mouse.y ) ){
				k = i;
			}
		}
		if ( g_mouse.L && !prev_mouseL && k!=-1 ) {

			int id = m_cntl_list_pattern.GetItemCount();
			char name[256];
			char fname_patt[256], save_patt[256];
			char fname_clip[256], save_clip[512];

			sprintf_s( name, sizeof(name), "P%03d", id );
			sprintf_s( fname_patt,sizeof(fname_patt),"%03d.patt",id);
			sprintf_s( save_patt, sizeof(save_patt), "Data/%s",fname_patt);
			sprintf_s( fname_clip,sizeof(fname_clip),"%03d.jpg",id);
			sprintf_s( save_clip,sizeof(save_clip),"Data/%s",fname_clip);
			
			ClipImage( imgARTK, imgClip, &marker_info[k] );
			cvSaveImage( save_clip, imgClip );
			arSavePatt( (ARUint8*)(imgARTK->imageData),&marker_info[k], save_patt );
			
			PATTERN_DATA patt;
			patt.enable = true;
			patt.name   = name;
			patt.filename = fname_patt;
			patt.id		= id;
			patt.width	= m_default_patt_width;

			InsertItemToList( patt );
		}
		prev_mouseL = g_mouse.L;


		for (int i=0; i<marker_num; i++) {
			if (k==i) {
				DrawMarkerLine2( imgARTK, &marker_info[i], CV_RGB(255,0,0));
			} else {
				DrawMarkerLine2( imgARTK, &marker_info[i], CV_RGB(255,255,0));
			}
		}	
		cvShowImage(win,imgARTK);
		int key = cvWaitKey(1);
		if (key==0x1B) break;	// ESC

		// should be after cvWaitKey()
		void* win_is_active = cvGetWindowHandle(win);
		if ( !win_is_active ) break;
	}

	// Release image processing element
	cvDestroyWindow(win);
	cvReleaseImage(&imgARTK);
	cvReleaseImage(&imgClip);

//	cvReleaseCapture(&m_camera); // is this working??
//	m_camera = NULL;
	m_capture.Release();

	m_pPattCapThread = NULL;
	m_cntl_button_patt_capture.EnableWindow(true);
	m_button_start.EnableWindow(true);
	m_button_stop.EnableWindow(true);

	TRACE("Pattern Capture Thread is end\n");
}


// Thread (Main)
void CVisionServerDlg::Thread()
{
	m_loopEnable = true;
	EnableServer();

	// Window Setup --------------------------------------------------------------------------
	BOOL use_win = false;
	BOOL show_preview = false;
	char *win = "Preview";

	// Image for ARToolKit Setup -------------------------------------------------------------
//	int width = cvQueryFrame(m_camera)->width;
//	int height = cvQueryFrame(m_camera)->height;
	int width = m_capture.QueryFrame()->width;
	int height = m_capture.QueryFrame()->height;

	IplImage* imgARTK = cvCreateImage(cvSize(width,height),IPL_DEPTH_8U, 4);
	IplImage* imgFrame = NULL;	// do not release

	// Pattern Setup -------------------------------------------------------------------------
	RegisterPattern( m_pattern_list );

	// Camera parameter setup ----------------------------------------------------------------
	ARParam cparam;
	ARParam wparam;
	arParamLoad("Data/camera_para.dat",1,&wparam);
	arParamChangeSize(&wparam,width,height,&cparam);
	arParamDisp(&cparam);
	arInitCparam(&cparam);

	// Begin server listen ------------------------------------------------------------------
	m_net.listen(m_edit_port,Server);

	// Image Processing Loop
	while (m_loopEnable) {
		show_preview = m_cntl_check_preview.GetCheck();

		if ( show_preview && !use_win ) {
			cvNamedWindow(win);
			use_win = true;
		}
		if ( !show_preview && use_win ) {
			cvDestroyWindow(win);
			use_win = false;
		}

		for (int i=0; i<m_cntl_list_pattern.GetItemCount(); i++) {
			if (m_cntl_list_pattern.GetCheck(i)) {
				arActivatePatt(i);
			} else {
				arDeactivatePatt(i);
			}
		}
		//imgFrame = cvQueryFrame(m_camera);
		imgFrame = m_capture.QueryFrame();

		g_mtMarkerInfo.lock();
			Detection( imgFrame, imgARTK, 100, m_pattern_list, g_markerInfo );
			if ( show_preview ) {
				for (unsigned int j=0; j<g_markerInfo.size(); j++) {
					DrawMarkerInfo( imgARTK, g_markerInfo[j] );
				}
			}
		g_mtMarkerInfo.unlock();

		if ( show_preview ) {
			cvShowImage(win,imgARTK);
			cvWaitKey(1);
			void* win_is_active = cvGetWindowHandle(win);
			if (!win_is_active) {
				m_cntl_check_preview.SetCheck(false);
			}
		}


		// ɏo͕\
		CString output;
		char all[2048];
		char ibuf[1024];
		g_mtMarkerInfo.lock();

//		sprintf_s( all, sizeof(all), "%d\r\n", g_markerInfo.size() );
		sprintf_s( all, sizeof(all), "Num= %d\r\n", g_markerInfo.size() );
		for ( unsigned int j=0; j<g_markerInfo.size(); j++) {
			MakeMarkerInfoString( g_markerInfo[j], g_enable_list, ibuf, sizeof(ibuf) );
			strcat_s( all, sizeof(all), ibuf );
			strcat_s( all, sizeof(all), "\r\n" );
		}
		output = all;
		m_cntl_edit_output.SetWindowTextW(output);
		g_mtMarkerInfo.unlock();
	}

	// Release image processing element
	if ( use_win ) cvDestroyWindow(win);
	cvReleaseImage(&imgARTK);

	//	cvReleaseCapture(&m_camera); // Is this working?
	//	m_camera = NULL;
	m_capture.Release();

	// Release pattern info
	for (unsigned int i=0; i<m_pattern_list.size(); i++) arFreePatt(i);

	DisableServer();
	m_net.stop_listen();
	m_pThread = NULL;
	UnlockInterface();

	TRACE("Main Thread is end\n");
}


int CVisionServerDlg::MakeDataFormat(void)
{
	UpdateData(true);

	g_enable_list.name  = m_check_name;
	g_enable_list.pos2d = m_check_pos2d;
	g_enable_list.dvec  = m_check_dvec;
	g_enable_list.pos3d = m_check_pos3d;
	g_enable_list.glmatrix = m_check_glmatrix;
	g_enable_list.cf       = m_check_cf;
	g_enable_list.area     = m_check_area;
	g_enable_list.vertex   = m_check_vertex;

	char format[512];
	MakeDataFormatString(g_enable_list,format,sizeof(format));
	char all[512];
	sprintf_s( all, sizeof(all), "Num= <count>\r\n%s",format);
	m_edit_data_format = all;

	UpdateData(false);
	return 0;


}
int CVisionServerDlg::InitList(void)
{
    LVCOLUMN    lvc;
    int         i;
	TCHAR       caption[][32] = {_T("Name"), _T("Width [mm]") };
    const int   clmNum = sizeof caption / sizeof caption[0];
    int         err = 0;

	m_cntl_list_pattern.SetExtendedStyle(LVS_EX_FULLROWSELECT);
	m_cntl_list_pattern.SetExtendedStyle((m_cntl_list_pattern.GetExtendedStyle()|LVS_EX_CHECKBOXES));

    lvc.mask = LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
    for (i = 0; i < clmNum; i++) {
        lvc.iSubItem    = i;
        lvc.pszText     = caption[i];
        lvc.cx          = 100;
        if (m_cntl_list_pattern.InsertColumn(i, &lvc) == -1) {err = 1; break;}
    }
    
    return err;
}

int CVisionServerDlg::InsertItemToList( PATTERN_DATA pattData )
{
	LVITEM       lvi;
	CString      str;
	int          index = 0;
	int          err = 0;

    lvi.mask = LVIF_TEXT;

	// Name
    if (!err)
    {
		str = pattData.name.c_str();
        lvi.iItem = m_cntl_list_pattern.GetItemCount();
		lvi.iSubItem = 0;
        lvi.pszText = const_cast<LPTSTR>(static_cast<LPCTSTR>(str));
        if ((index = m_cntl_list_pattern.InsertItem(&lvi)) == -1) err = 1;
    }

	// Check
	if (pattData.enable) {
		m_cntl_list_pattern.SetCheck(index);
	}

	// Width
    if (!err)
    {
        str.Format(_T("%.1lf"), pattData.width);
        lvi.iItem = index;
        lvi.iSubItem = 1;
        lvi.pszText = const_cast<LPTSTR>(static_cast<LPCTSTR>(str));
        if (!m_cntl_list_pattern.SetItem(&lvi)) err = 1;
    }

	// focus
	m_cntl_list_pattern.SetItemState( index, LVIS_SELECTED|LVIS_FOCUSED,LVIS_SELECTED|LVIS_FOCUSED );

    return err;

}

void CVisionServerDlg::OnNMRClickListPattern(NMHDR *pNMHDR, LRESULT *pResult)
{
	CMenu menu;
	menu.CreatePopupMenu();

	if ( m_pThread ) {
		menu.AppendMenu(MF_STRING|MF_GRAYED,IDM_DELETE_ITEM ,_T("Remove this pattern") );
	} else {
		menu.AppendMenu(MF_STRING|MF_ENABLED,IDM_DELETE_ITEM ,_T("Remove this pattern") );
	}
	POINT point;
	GetCursorPos(&point);
	menu.TrackPopupMenu( TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y, this );
	menu.DestroyMenu();

	*pResult = 0;
}


int CVisionServerDlg::EnableServer(void)
{
	g_mtServerEnable.lock();
		g_serverEnable = true;
	g_mtServerEnable.unlock();

	return 0;
}

int CVisionServerDlg::DisableServer(void)
{
	g_mtServerEnable.lock();
		g_serverEnable = false;
	g_mtServerEnable.unlock();

	return 0;
}



// Click on pattern list
void CVisionServerDlg::OnLvnItemchangedListPattern(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);

	if ((pNMLV->uNewState & LVIS_SELECTED) && !(pNMLV->uOldState & LVIS_SELECTED)) {
		UpdateData(true);

		// Show pattern
		char filename[256];
		sprintf_s(filename,sizeof(filename),"Data/%03d.jpg",pNMLV->iItem);
		m_imgPatt = cvLoadImage(filename);
		ShowImage( IDC_PICT_PATT, m_imgPatt );

		// Show info on editbox
		m_edit_patt_name = m_cntl_list_pattern.GetItemText( pNMLV->iItem, 0 );
		m_edit_patt_width = _tstof(m_cntl_list_pattern.GetItemText(pNMLV->iItem, 1));
		UpdateData(false);
	}

	*pResult = 0;
}


void CVisionServerDlg::DeleteItemFromList(void)
{
	int index = -1;
	while ((index = m_cntl_list_pattern.GetNextItem(index, LVNI_ALL |LVNI_SELECTED)) != -1){

		int old_num = m_cntl_list_pattern.GetItemCount();

		char filename[256];
		sprintf_s( filename, sizeof(filename), "Data/%03d.patt",index );
		remove(filename);
		TRACE("Remove: %s\n",filename);

		sprintf_s( filename, sizeof(filename), "Data/%03d.jpg",index );
		remove(filename);
		TRACE("Remove: %s\n",filename);

		for (int i=index+1; i<old_num; i++) {
			char oldname[256];
			char newname[256];
			sprintf_s( oldname, sizeof(oldname), "Data/%03d.patt",i);
			sprintf_s( newname, sizeof(newname), "Data/%03d.patt",i-1);
			rename( oldname, newname );
			TRACE("Rename: %s->%s\n",oldname,newname);
			sprintf_s( oldname, sizeof(oldname), "Data/%03d.jpg",i);
			sprintf_s( newname, sizeof(newname), "Data/%03d.jpg",i-1);
			rename( oldname, newname );
			TRACE("Rename: %s->%s\n",oldname,newname);
		}
		m_cntl_list_pattern.DeleteItem(index);
		m_cntl_list_pattern.SetItemState( index, LVIS_SELECTED|LVIS_FOCUSED,LVIS_SELECTED|LVIS_FOCUSED );

		if ( m_cntl_list_pattern.GetItemCount()==0 ) {
			m_imgPatt = cvLoadImage("no_pattern.bmp");
			ShowImage( IDC_PICT_PATT, m_imgPatt );
			m_edit_patt_name = _T("");
			m_edit_patt_width = 0;
			UpdateData(false);
		}
	}
}

void CVisionServerDlg::OnBnClickedButtonSavePatternInfo()
{
	int index = -1;
	while ((index = m_cntl_list_pattern.GetNextItem(index, LVNI_ALL |LVNI_SELECTED)) != -1){
		UpdateData(true);
		m_cntl_list_pattern.SetItemText( index, 0, m_edit_patt_name );
		CString str;
		str.Format(_T("%.1lf"), m_edit_patt_width );
		m_cntl_list_pattern.SetItemText( index, 1, const_cast<LPTSTR>(static_cast<LPCTSTR>(str)) );
		UpdateData(false);
	}
}


void CVisionServerDlg::OnBnClickedCheckName()
{
	MakeDataFormat();
}
void CVisionServerDlg::OnBnClickedCheckPos2d()
{
	MakeDataFormat();
}

void CVisionServerDlg::OnBnClickedCheckDvec()
{
	MakeDataFormat();
}

void CVisionServerDlg::OnBnClickedCheckPos3d()
{
	MakeDataFormat();
}

void CVisionServerDlg::OnBnClickedCheckArea()
{
	MakeDataFormat();
}

void CVisionServerDlg::OnBnClickedCheckCf()
{
	MakeDataFormat();
}

void CVisionServerDlg::OnBnClickedCheckVertex()
{
	MakeDataFormat();
}

void CVisionServerDlg::OnBnClickedCheckGlmatrix()
{
	MakeDataFormat();
}